/*#######################################################################################
AVR Small Webserver 

Copyright (C) 2004 Ulrich Radig

#######################################################################################*/

#ifndef _ARP_H
 #define _ARP_H
 
//Prototype
extern void ARP_Reply (char *,int *);

//Aufbau eines ARP Header
//	
//	2 BYTE Hardware Typ				|	2 BYTE Protokoll Typ	
//	1 BYTE Lnge Hardwareadresse	|	1 BYTE Lnge Protokolladresse
//	2 BYTE Operation
//	6 BYTE MAC Adresse Absender		|	4 BYTE IP Adresse Absender
//	6 BYTE MAC Adresse Empfnger	|	4 BYTE IP Adresse Empfnger	

#define ARP_OFFSET				0x0E

//ARP Layout
struct ARP_Header	{
		unsigned int ARP_HWType;		//Hardware Typ enthlt den Code fr Ethernet oder andere Link Layer
		unsigned int ARP_PRType;		//Protokoll Typ enthlt den Code fr IP o. anderes bertragungsprotokoll
		unsigned char ARP_HWLen;		//Lnge der Hardwareadresse enthlt 6 fr 6 Byte lange MAC Adressen
		unsigned char ARP_PRLen;		//Lnge der Protocolladresse enthlt 4 fr 4 Byte lange IP Adressen
		unsigned int ARP_Op;			//Enthlt Code der signalisiert ob es sich um eine Anfrage o. Antwort handelt
		unsigned char ARP_SHAddr[6];	//Enthlt die MAC Adresse des Anfragenden  
		unsigned long ARP_SIPAddr;		//Enthlt die IP Adresse des Absenders
		unsigned char ARP_THAddr[6];	//MAC Adresse Ziel, ist in diesem Fall 6 * 00,da die Adresse erst noch herausgefunden werden soll (ARP Request)
		unsigned long ARP_TIPAddr;		//IP Adresse enthlt die IP Adresse zu der die Kommunikation aufgebaut werden soll 
};

#endif // #define _ARP_H
