/*#######################################################################################
AVR Small Webserver 

Copyright (C) 2004 Ulrich Radig

#######################################################################################*/

#ifndef _TCP_H
 #define _TCP_H

struct TCP_Socket {
	unsigned int Store;
	PGM_P Pointer;
	unsigned char Status;
	
	#if USE_MMC
		unsigned int Cluster;
		unsigned long File_Size;
		unsigned int File_Block_Counter;
	#endif
};

//Prototype
extern struct TCP_Socket tcpsockets[];
extern struct TCP_Socket *tcp_socket;

extern PGM_P pointerold;

extern void tcp_store (char *);
extern unsigned char tcp_add_data (PGM_P ,char *,int *);
extern char tcp_add_datastring (char *pointer,char *buffer,int *bufferlen);
extern void TCP_New_Packtlen (char *buffer,int *bufferlen,unsigned int result16);
extern void tcp_make (char *);
extern void TCP_PORT_CLOSE (char *,int *);
extern int TCP_OPEN (char *,int *);
extern char TCP_Stack (char *buffer,int *bufferlen,unsigned char *Stackpointer);

#define Max_TCP_Sockets  7

#define TCP_OFFSET				0x22
//TCP Header Layout

struct TCP_Header	{
	unsigned int 	TCP_SrcPort;	//der Quellport fr die Verbindung (Socket)
	unsigned int 	TCP_DestPort;	//der Zielport fr die Verbindung (Socket)
	unsigned char	TCP_Seqnum[4];	//numerierter Bytestrom
	unsigned char	TCP_Acknum[4];	//numerierter Bytestrom (Gegenrichtung)
	unsigned char	TCP_HdrFlags[2];//4Bit Lnge des Headers in 32 Bit schritten rest Flags
	unsigned int	TCP_Window;		//Fenstergre max. 64K Byte
	unsigned int	TCP_Chksum;		//Enthlt eine Prfsumme ber Header und Datenbereich
	unsigned int	TCP_UrgentPtr;	//16 Bit fr dringende bertragung
};

#define	TCP_SRCPORT				TCP_OFFSET+0x00	//der Quellport fr die Verbindung (Socket)
#define	TCP_DESTPORT			TCP_OFFSET+0x02	//der Zielport fr die Verbindung (Socket)
#define	TCP_SEQNUM				TCP_OFFSET+0x04	//numerierter Bytestrom
#define	TCP_ACKNUM				TCP_OFFSET+0x08	//numerierter Bytestrom (Gegenrichtung)
#define	TCP_HDRFLAGS			TCP_OFFSET+0x0C	//4Bit Lnge des Headers in 32 Bit schritten 
												//rest Flags
#define	TCP_WINDOW				TCP_OFFSET+0x0E	//Fenstergre max. 64K Byte
#define	TCP_CHKSUM				TCP_OFFSET+0x10	//Enthlt eine Prfsumme ber Header und 
												//Datenbereich
#define	TCP_URGENTPTR			TCP_OFFSET+0x12	//16 Bit fr dringende bertragung

//TCP Flags
#define  FIN_FLAG				0x01	//Datenbertragung beendet (finished)
#define  SYN_FLAG				0x02	//Verbindungs aufbauen (synchronize)
#define  RST_FLAG				0x04	//Verbindung neu initialisieren (reset)
#define  PSH_FLAG				0x08	//Datenbergabe an Anwendung beschleunigen (push)
#define  ACK_FLAG				0x10	//Datenbertragung besttigen (acknowledged)

//TCP_Status
#define TCP_SOCKET_NOT_USE		0	//TCP Port geschlossen
#define TCP_SOCKET_OPEN1		1	//TCP Port geffnet
#define TCP_SOCKET_OPEN2		2	//TCP Port geffnet 1. ACK wurde abgearbeitet
#define TCP_SOCKET_CLOSE		3	//TCP Port wird bei nchsten ACK geschlossen


#endif // _TCP_H
